package com.diagbot.enums;

import com.diagbot.core.KeyedNamed;
import lombok.Setter;

/**
 * @Description:
 * @Author:zhaops
 * @time: 2021/6/10 14:43
 */
public enum RetrievalTypeEnum implements KeyedNamed {
    //1-化验大项、2-化验小项、3-辅检、4-诊断、5-药品、6-手术和操作、7-科室、8-输血、9-症状、10-量表、11-护理、14-麻醉
    LisName(1, "实验室检查套餐"),
    LisSubName(2, "实验室检查子项目"),
    PacsName(3, "辅助检查项目"),
    Disease(4, "疾病"),
    Medicine(5, "药品通用名"),
    Operation(6, "手术和操作"),
    Dept(7, "科室"),
    Transfusion(8, "输血类型"),
    Symptom(9,"症状"),
    Scale(10, "量表"),
    Nurse(11, "护理"),
    TcmDisease(12,"中医疾病"),
    TcmSyndrome(13,"中医证候"),
    Anesthesia(14, "麻醉"),
    Form(15, "药品剂型");

    @Setter
    private int key;

    @Setter
    private String name;

    RetrievalTypeEnum(int key, String name) {
        this.key = key;
        this.name = name;
    }

    public static RetrievalTypeEnum getEnum(int key) {
        for (RetrievalTypeEnum item : RetrievalTypeEnum.values()) {
            if (item.key == key) {
                return item;
            }
        }
        return null;
    }

    public static RetrievalTypeEnum getEnum(String value) {
        for (RetrievalTypeEnum item : RetrievalTypeEnum.values()) {
            if (item.getName().equals(value)) {
                return item;
            }
        }
        return null;
    }

    public static String getName(int key) {
        RetrievalTypeEnum item = getEnum(key);
        return item != null ? item.name : null;
    }

    @Override
    public int getKey() {
        return key;
    }

    @Override
    public String getName() {
        return name;
    }
}